/**
 * 流程图绘制工具
 */
//项目节点对象
var stage;//布景
var shape;//图形容器
var graphics;//图形
var lineColor = "black";//线段颜色
var framesArray =[[30,3,126,54],[207,3,126,54],[384,3,126,54],[30,87,126,54],[207,87,126,54],[384,87,126,54],[30,171,126,54],[207,171,126,54],[384,171,126,54],[30,254,126,54],[207,254,126,54],[384,254,126,54],[30,339,126,54],[207,339,126,54],[384,339,126,54]];
//var animationsObj ={"0":[0],"1":[1],"2":[2],"3":[3],"4":[4],"5":[5],"6":[6],"7":[7],"8":[8],"9":[9],"10":[10],"11":[11],"12":[12],"13":[13],"14":[14]}; 
var animationsObj ={"a":[3],"b":[5],"c":[0],"d":[10]};
var DrawingTools = function(data){
	this.data = data;
}
DrawingTools.prototype={
	init:function(){
		stage = new createjs.Stage("myCanvas");
		stage.enableMouseOver(20);
		shape = new createjs.Shape();
		graphics = shape.graphics;
		stage.addChild(shape);
	},
	drawingImage:function(){
		var dt = this;
		var img = new Image();
		img.src = "img/button_2.png";
		img.onload = function(event){
			var data = {images: [img], frames:framesArray ,animations:animationsObj};
			var spriteSheet = new createjs.SpriteSheet(data);
			for(var i =0 ;i< dt.data.nodes.length;i++){
				var node = dt.data.nodes[i];
				var image = dt.getImage(node.x,node.y,node.type,spriteSheet);
				stage.addChild(image);
			}
			dt.drawingText();
		}
	},
	getImage:function(x,y,type,spriteSheet){
		var icon = new createjs.Sprite(spriteSheet);
		icon.x = x;
		icon.y = y;
		icon.gotoAndStop(type);
		return icon;
	},
	drawingText:function(){
		for(var i =0 ;i< this.data.nodes.length;i++){
			var node = this.data.nodes[i];
			var ponintRole = [(126+node.x*2)/2,(node.y*2+25)/2];
			var txtRole = this.getText(node.role,"bold 16px Arial","black",ponintRole);
			var ponintUser = [(126+node.x*2)/2,(node.y*2+64)/2];
			var txtUser = this.getText(node.user,"11px Arial","black",ponintUser);
			stage.addChild(txtRole);
			stage.addChild(txtUser);
		}
		stage.update();
	},
	getText:function(txt,font,color,point){
		var text = new createjs.Text(txt,font,color);
		text.x = point[0];
		text.y = point[1];
		text.textAlign = 'center';
		return text;
	},
	drawingLineArrow:function(){
		for(var i =0;i<this.data.lines.length;i++){
			var line = this.data.lines[i];
			var sPoint = line.sPoint;
			var ePoint = line.ePoint;
			sPoint = this.getLinePlugs(sPoint,line.fx);
			ePoint = this.getLinePlugs(ePoint,line.fx);
			var du = angle({x:sPoint.x,y:sPoint.y},{x:ePoint.x,y:ePoint.y});
			graphics.beginStroke(lineColor).moveTo(sPoint.x,sPoint.y).lineTo(ePoint.x,ePoint.y);
			var lineDu = du;
			
			if(sPoint.plugs=="right" && ePoint.plugs=="left" && line.fx == "back"){
				lineDu =  du - 60 - 60;
			}else{
				if( line.fx == "back" ){
					lineDu =  60 - du;
				}
				if(sPoint.plugs=="left" && ePoint.plugs=="right" && line.fx == "go"){
					lineDu =  60- du ;
				}
			}
			
	    	graphics.beginFill(lineColor).drawPolyStar(ePoint.x,ePoint.y, 5, 3, 0.55, lineDu).endStroke();
	    	if(line.href == undefined || line.href == null){
	    		var txt = this.getLineArrowText(sPoint,ePoint,line.text,du,line.fx);
	    		stage.addChild(txt);
	    	}else{
	    		var txt = this.getLineArrowTextLink(sPoint,ePoint,line.text,du,line.fx,line.href);
	    		stage.addChild(txt);
	    	}
		}
	    stage.update();
	},
	getLineArrowTextLink:function(sPoint,ePoint,text,du,fx,value){
		var s_x = sPoint.x;
		var s_y = sPoint.y;
		var e_x = ePoint.x;
		var e_y = ePoint.y;
	    //中心
		var centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2];
		var regY = -3;
		var regX = -3;
		if(sPoint.plugs=="right"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2-10];
				regY = 10;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2+10];
				regY = 10;
				regX = 0;
			}
		}else if(sPoint.plugs=="left"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2-10];
				regY = 10;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2+10];
				regY = 5;
				regX = 0;
			}
		}else if(sPoint.plugs=="bottom"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2-10,(s_y+e_y)/2];
				regY = 0;
				regX = -40;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2+10,(s_y+e_y)/2];
				regY = 0;
				regX = 20;
			}
		}else if(sPoint.plugs=="top"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2+10,(s_y+e_y)/2];
				regY = 0;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2-10,(s_y+e_y)/2];
				regY = 5;
				regX = 20;
			}
		}
		var link = new TextLink(text,"16px Arial","red","#fff",value);
		link.x = centerPonitn[0];
		link.y = centerPonitn[1];
		link.addEventListener("click", toolsBack);
		link.cursor = "pointer";
		link.textAlign = 'center';
		link.regY = regY;
		link.regX = regX;
		
		return link;
	},
	getLineArrowText:function(sPoint,ePoint,text,du,fx){
		var s_x = sPoint.x;
		var s_y = sPoint.y;
		var e_x = ePoint.x;
		var e_y = ePoint.y;
	    //中心
		var centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2];
		var regY = -3;
		var regX = -3;
		if(sPoint.plugs=="right"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2-10];
				regY = 10;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2+10];
				regY = 10;
				regX = 0;
			}
		}else if(sPoint.plugs=="left"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2-10];
				regY = 10;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2,(s_y+e_y)/2+10];
				regY = 5;
				regX = 0;
			}
		}else if(sPoint.plugs=="bottom"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2-10,(s_y+e_y)/2];
				regY = 0;
				regX = -40;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2+10,(s_y+e_y)/2];
				regY = 0;
				regX = 20;
			}
		}else if(sPoint.plugs=="top"){
			if(fx == "go"){
				centerPonitn = [(s_x+e_x)/2+10,(s_y+e_y)/2];
				regY = 0;
				regX = 0;
			}else if(fx == "back"){
				centerPonitn = [(s_x+e_x)/2-10,(s_y+e_y)/2];
				regY = 5;
				regX = 20;
			}
		}
		var txt = this.getText(text,"16px Arial","red",centerPonitn);
//		txt.rotation = du;
		txt.regY = regY;
		txt.regX = regX;
		
		
		return txt;
	},
	getLinePlugs:function(point,fx){
		if(point.plugs=="right"){
			point.x = point.x + 126;
			point.y = point.y + 27;
			if(fx == "go"){
				point.y = point.y - 5;
				point.x = point.x + 5;
			}else if(fx == "back"){
				point.y = point.y + 5;
				point.x = point.x + 5;
			}
		}else if(point.plugs=="left"){
			point.x = point.x - 5;
			point.y = point.y + 27;
			if(fx == "go"){
				point.y = point.y - 5;
			}else if(fx == "back"){
				point.y = point.y + 5;
			}
		}else if(point.plugs=="bottom"){
			point.x = point.x + 63;
			point.y = point.y + 27;
			if(fx == "go"){
				point.x = point.x + 5;
				point.y = point.y + 20;
			}else if(fx == "back"){
				point.x = point.x - 10;
				point.y = point.y + 35;
			}
		}else if(point.plugs=="top"){
			point.x = point.x + 63;
			point.y = point.y - 5;
			if(fx == "go"){
				point.x = point.x + 5;
			}else if(fx == "back"){
				point.x = point.x - 10;
				point.y = point.y + 10;
			}
		}
		return point;
	},
	build:function(){
		this.drawingImage();
		this.drawingLineArrow();
		createjs.Ticker.addEventListener("tick", stage);
	}
}
//计算角度
function angle(start,end){
	var diff_x = end.x - start.x,
        diff_y = end.y - start.y;
    //返回角度,不是弧度
    return 360*Math.atan(diff_y/diff_x)/(2*Math.PI);
}

function TextLink(text, font, color, hoverColor,value) {
		// this super class constructor reference is automatically created by createjs.extends:
		this.Text_constructor(text, font, color);
		this.hoverColor = hoverColor;
		this.hover = false;
		this.hitArea = new createjs.Shape();
		this.textBaseline = "top";
		this.value = value;

		this.addEventListener("rollover", this);
		this.addEventListener("rollout", this);
	}
	createjs.extend(TextLink, createjs.Text);

	// use the same approach with draw:
	TextLink.prototype.draw = function (ctx, ignoreCache) {
		// save default color, and overwrite it with the hover color if appropriate:
		var color = this.color;
		if (this.hover) {
			this.color = this.hoverColor;
		}

		// call Text's drawing method to do the real work of drawing to the canvas:
		// this super class method reference is automatically created by createjs.extends for methods overridden in the subclass:
		this.Text_draw(ctx, ignoreCache);

		// restore the default color value:
		this.color = color;

		// update hit area so the full text area is clickable, not just the characters:
		this.hitArea.graphics.clear().beginFill("#FFF").drawRect(0, 0, this.getMeasuredWidth(), this.getMeasuredHeight());
	};

	// set up the handlers for mouseover / out:
	TextLink.prototype.handleEvent = function (evt) {
		this.hover = (evt.type == "rollover");
	};

	// set up the inheritance relationship: TextLink extends Text.
	createjs.promote(TextLink, "Text");